package homework3_2;

class Tests {
    public static void main(String[] args) {
        /* 7. В методе main написать несколько тестов на реализованный функционал. */
        System.out.println("Test 7. Смотрим ниже");
        Library library = new Library();

        /* 1. Добавить новую книгу в библиотеку, если книги с таким наименованием ещё нет
        в библиотеке. Если книга в настоящий момент одолжена, то считается, что она
        всё равно есть в библиотеке (просто в настоящий момент недоступна). */
        System.out.println("Test 1");
        library.addBook("Глен Кук", "Хроники чёрного отряда");
        library.addBook("Рафаэль Сабатини", "Одисея капитана Блада");
        library.addBook("Рафаэль Сабатини", "Хроники капитана Блада");
        library.addBook("Френк Герберт", "Дюна");
        library.addBook("Герберт Уеллс", "Человек-Невидимка");
        System.out.println("! Добавление имеющейся книги !");
        library.addBook("Герберт Уеллс", "Человек-Невидимка"); // Добавление имеющейся книги

        /* 2. Удалить книгу из библиотеки по названию, если такая книга в принципе есть в
        библиотеке и она в настоящий момент не одолжена. */
        // По рейтингу в конце
        System.out.println("Test 2 удалить книгу");
        library.deleteBook("Человек-Невидимка");
        System.out.println("! Проверка !");
        library.searchBook("Человек-Невидимка");

        /* 3. Найти и вернуть книгу по названию. */
        System.out.println("Test 3");
        library.searchBook("Дюна");
        library.searchBook("Хроники чёрного отряда");
        // Или имеется в виду вернуть объект???
        Book book = library.searchBookO("Хроники чёрного отряда");

        /* 4. Найти и вернуть список книг по автору. */
        System.out.println("Test 4");
        library.searchAuthor("Самый лучший");
        library.searchAuthor("Рафаэль Сабатини");

        /* Механизм одалживания книги посетителю. Каждый посетитель в один момент времени
        может читать только одну книгу. */
        System.out.println("! Посетители !");
        library.addVisitor("Иван Иванов");
        library.addVisitor("Пётр Петров");
        /* 5. Одолжить книгу посетителю по названию, если выполнены все условия:
        a. Она есть в библиотеке.
        b. У посетителя сейчас нет книги.
        c. Она не одолжена. */
        System.out.println("Test 5");
        System.out.println("Вывод информации о посетителях"); // предполагается что клиент знает свой идентификатор
        for (int i = 0; i < library.visitors.size(); i++) { // Вывод информации о посетителях
            library.printVisitor(i);
        }
        System.out.println("! Аренда книги !");
        /* Также если посетитель в первый раз обращается за книгой — дополнительно
        выдать ему идентификатор читателя. */
        library.bookRental(0, "Дюна"); // Аренда
        System.out.println("Аренда отсутствующей книги");
        library.bookRental(0, "Незнайка на луне");
        System.out.println("Аренда некорректного id");
        library.bookRental(99, "Хроники чёрного отряда");

        /* 6. Вернуть книгу в библиотеку от посетителя, который ранее одалживал книгу. Не
        принимать книгу от другого посетителя.
                a. Книга перестает считаться одолженной.
                b. У посетителя не остается книги.
        Тестирование. */
        System.out.println("Test 6");
        library.bookReturn(0, "Дюна", 8);
        library.printVisitor(0); // Статус тру - не должник
        System.out.println("Test 7. Обозначен в начале");

                 // Дополнительная задача*:
        /* 8. Добавить функционал оценивания книг посетителем при возвращении в
        библиотеку. Оценка книги рассчитывается как среднее арифметическое оценок
        всех посетителей, кто брал эту книгу. */
        System.out.println("Test 8");
        library.bookRental(1, "Дюна");
        library.bookReturn(1, "Дюна", 9);
        library.bookRental(0, "Дюна");
        library.bookReturn(0, "Дюна", 5);
        library.bookRental(1, "Дюна");
        library.bookReturn(1, "Дюна", 6);
        System.out.println("Оценки 8, 9, 5, 6. Среднее значение (8+9+5+6)/4 = " + (8+9+5+6)/4);

        /* Реализовать метод, возвращающий оценку книги по её наименованию. */
        System.out.println("Оценка книги Дюна " + library.searchBookRateName("Дюна"));
    }
}
